// If this code works, it was written by Svetlio Kapralov. If not, I don't know who wrote it.
package net.playerfinder.jsf.components.selectonemenu;

import javax.faces.application.ResourceDependencies;
import javax.faces.application.ResourceDependency;
import javax.faces.component.FacesComponent;
import javax.faces.component.html.HtmlSelectOneMenu;

@FacesComponent(UISelectOneMenu.COMPONENT_TYPE)
@ResourceDependencies({
		@ResourceDependency(name = "jquery.js", library = "pfjs"),
		@ResourceDependency(name = "pf.no.conflicts.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.ui.core.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.ui.widget.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.ui.position.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.ui.selectmenu.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.ui.core.css", library = "css"),
		@ResourceDependency(name = "jquery.ui.theme.css", library = "css"),
		@ResourceDependency(name = "jquery.ui.selectmenu.css", library = "css") })
public class UISelectOneMenu extends HtmlSelectOneMenu {

	public static final String COMPONENT_TYPE = "net.playerfinder.jsf.components.selectonemenu.UISelectOneMenu";
	public static final String COMPONENT_FAMILY = "net.playerfinder.jsf.components";
	public static final String DEFAULT_RENDERER = "net.playerfinder.jsf.components.selectonemenu.UISelectOneMenuRenderer";

	protected enum PropertyKeys {
		mode, width, menuWidth, handleWidth, maxHeight, iconsWidth, iconsHeight, formatFunction;//, transferClasses;

		String toString;

		PropertyKeys(String toString) {
			this.toString = toString;
		}

		PropertyKeys() {
		}

		public String toString() {
			return ((this.toString != null) ? this.toString : super.toString());
		}
	}

	public UISelectOneMenu() {
		setRendererType(DEFAULT_RENDERER);
	}

	@Override
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

//	public boolean isTransferClasses() {
//		return (Boolean) getStateHelper().eval(PropertyKeys.transferClasses,
//				true);
//	}
//
//	public void setTransferClasses(boolean transferClasses) {
//		getStateHelper().put(PropertyKeys.transferClasses, transferClasses);
//	}

	public String getMode() {
		return (String) getStateHelper().eval(PropertyKeys.mode, "dropdown"); // "popup"
	}

	public void setMode(String mode) {
		getStateHelper().put(PropertyKeys.mode, mode);
	}

	public String getFormatFunction() {
		return (String) getStateHelper()
				.eval(PropertyKeys.formatFunction, null);
	}

	public void setFormatFunction(String formatFunction) {
		getStateHelper().put(PropertyKeys.formatFunction, formatFunction);
	}

	public Integer getWidth() {
		return (Integer) getStateHelper().eval(PropertyKeys.width, null);
	}

	public void setWidth(Integer width) {
		getStateHelper().put(PropertyKeys.width, width);
	}

	public Integer getMenuWidth() {
		return (Integer) getStateHelper().eval(PropertyKeys.menuWidth, null);
	}

	public void setMenuWidth(Integer menuWidth) {
		getStateHelper().put(PropertyKeys.menuWidth, menuWidth);
	}

	public Integer getHandleWidth() {
		return (Integer) getStateHelper().eval(PropertyKeys.handleWidth, 26);
	}

	public void setHandleWidth(Integer handleWidth) {
		getStateHelper().put(PropertyKeys.handleWidth, handleWidth);
	}

	public Integer getMaxHeight() {
		return (Integer) getStateHelper().eval(PropertyKeys.maxHeight, null);
	}

	public void setMaxHeight(Integer maxHeight) {
		getStateHelper().put(PropertyKeys.maxHeight, maxHeight);
	}

	public Integer getIconsWidth() {
		return (Integer) getStateHelper().eval(PropertyKeys.iconsWidth, null);
	}

	public void setIconsWidth(Integer iconsWidth) {
		getStateHelper().put(PropertyKeys.iconsWidth, iconsWidth);
	}

	public Integer getIconsHeight() {
		return (Integer) getStateHelper().eval(PropertyKeys.iconsHeight, null);
	}

	public void setIconsHeight(Integer iconsHeight) {
		getStateHelper().put(PropertyKeys.iconsHeight, iconsHeight);
	}
}
